package ShowXPath;

import java.io.*;
import java.util.*;

import ShowXPath.XPath.node.*;
import ShowXPath.XPath.lexer.*;

public class NewLexer extends Lexer
{
	private String _token = "";
	private String _oldOne;
	private String _kleene = "kleene";
	private String _star = "star";
	
	public NewLexer(PushbackReader in)
	{
		super(in);
	}
	
	public Token peek() throws LexerException, IOException
	{
		Token T = super.peek();

		String oldT = _token;
		String newT = T.getText();

		if (newT.equals("*"))
		{
			if (oldT.equals("") || oldT.equals("[") ||
			    oldT.equals("(") || oldT.equals("@") ||
			    oldT.equals(":") || oldT.equals("::") ||
			    oldT.equals("<") || oldT.equals(">") ||
			    oldT.equals("<=") || oldT.equals(">=") ||
			    oldT.equals("+") || oldT.equals("-") ||
			    oldT.equals("div") || oldT.equals("mod") ||
			    oldT.equals("=") || oldT.equals("!=") ||
			    oldT.equals("and") || oldT.equals("or") ||
			    (oldT.equals("*") && _oldOne.equals(_star))||
			    oldT.equals("/") || oldT.equals("//"))
			{
				if (T instanceof TKleeneTok)
				{
					return T;
				}
				else
				{
					return (Token) new TKleeneTok(T.getLine(), T.getPos());
				}
			}
			else
			{
				if (T instanceof TStarTok)
				{
					return T;
				}
				else
				{
					return (Token) new TStarTok(T.getLine(), T.getPos());
				}
				
			}
		}
		return T;
	}

	public Token next() throws LexerException, IOException
	{
		Token T = super.next();

		String oldT = _token;
		String newT = T.getText();

		if (T instanceof TBlankTok)
		{
		}
		else
		{
			_token = newT;
		}
		
		if (newT.equals("*"))
		{
			if (oldT.equals("") || oldT.equals("[") ||
			    oldT.equals("(") || oldT.equals("@") ||
			    oldT.equals(":") || oldT.equals("::") ||
			    oldT.equals("<") || oldT.equals(">") ||
			    oldT.equals("<=") || oldT.equals(">=") ||
			    oldT.equals("+") || oldT.equals("-") ||
			    oldT.equals("div") || oldT.equals("mod") ||
			    oldT.equals("=") || oldT.equals("!=") ||
			    oldT.equals("and") || oldT.equals("or") ||
			    (oldT.equals("*") && _oldOne.equals(_star))||
			    oldT.equals("/") || oldT.equals("//"))
			{
				_oldOne = _kleene;
				if (T instanceof TKleeneTok)
				{
					return T;
				}
				else
				{
					return (Token) new TKleeneTok(T.getLine(), T.getPos());
				}
			}
			else
			{
				_oldOne = _star;
				if (T instanceof TStarTok)
				{
					return T;
				}
				else
				{
					return (Token) new TStarTok(T.getLine(), T.getPos());
				}
			}
		}
		return T;
	}
}

	
