/* This file was generated by SableCC (http://www.sable.mcgill.ca/sablecc/). */

package ShowXPath.XPath.parser;

import ShowXPath.XPath.lexer.*;
import ShowXPath.XPath.node.*;
import ShowXPath.XPath.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("Unable to read parser.dat.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(28), node, false); } break;
                    case 3: { Node node = new3(); push(goTo(28), node, false); } break;
                    case 4: { Node node = new4(); push(goTo(1), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(1), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(1), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(1), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(1), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(1), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(1), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(1), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(1), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(1), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(1), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(1), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(1), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(2), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(2), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(3), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(3), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(3), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(4), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(4), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(4), node, true); } break;
                    case 25: { Node node = new25(); push(goTo(4), node, true); } break;
                    case 26: { Node node = new26(); push(goTo(4), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(4), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(5), node, true); } break;
                    case 29: { Node node = new29(); push(goTo(5), node, true); } break;
                    case 30: { Node node = new30(); push(goTo(6), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(6), node, true); } break;
                    case 32: { Node node = new32(); push(goTo(6), node, true); } break;
                    case 33: { Node node = new33(); push(goTo(6), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(6), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(6), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(6), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(6), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(6), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(6), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(6), node, true); } break;
                    case 41: { Node node = new41(); push(goTo(6), node, true); } break;
                    case 42: { Node node = new42(); push(goTo(6), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(6), node, true); } break;
                    case 44: { Node node = new44(); push(goTo(6), node, true); } break;
                    case 45: { Node node = new45(); push(goTo(6), node, true); } break;
                    case 46: { Node node = new46(); push(goTo(6), node, true); } break;
                    case 47: { Node node = new47(); push(goTo(6), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(6), node, true); } break;
                    case 49: { Node node = new49(); push(goTo(6), node, true); } break;
                    case 50: { Node node = new50(); push(goTo(6), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(6), node, true); } break;
                    case 52: { Node node = new52(); push(goTo(6), node, true); } break;
                    case 53: { Node node = new53(); push(goTo(6), node, true); } break;
                    case 54: { Node node = new54(); push(goTo(6), node, true); } break;
                    case 55: { Node node = new55(); push(goTo(6), node, true); } break;
                    case 56: { Node node = new56(); push(goTo(6), node, true); } break;
                    case 57: { Node node = new57(); push(goTo(6), node, true); } break;
                    case 58: { Node node = new58(); push(goTo(6), node, true); } break;
                    case 59: { Node node = new59(); push(goTo(6), node, true); } break;
                    case 60: { Node node = new60(); push(goTo(6), node, true); } break;
                    case 61: { Node node = new61(); push(goTo(6), node, true); } break;
                    case 62: { Node node = new62(); push(goTo(6), node, true); } break;
                    case 63: { Node node = new63(); push(goTo(6), node, true); } break;
                    case 64: { Node node = new64(); push(goTo(6), node, true); } break;
                    case 65: { Node node = new65(); push(goTo(6), node, true); } break;
                    case 66: { Node node = new66(); push(goTo(7), node, true); } break;
                    case 67: { Node node = new67(); push(goTo(8), node, true); } break;
                    case 68: { Node node = new68(); push(goTo(8), node, true); } break;
                    case 69: { Node node = new69(); push(goTo(29), node, false); } break;
                    case 70: { Node node = new70(); push(goTo(29), node, false); } break;
                    case 71: { Node node = new71(); push(goTo(9), node, true); } break;
                    case 72: { Node node = new72(); push(goTo(9), node, true); } break;
                    case 73: { Node node = new73(); push(goTo(9), node, true); } break;
                    case 74: { Node node = new74(); push(goTo(9), node, true); } break;
                    case 75: { Node node = new75(); push(goTo(9), node, true); } break;
                    case 76: { Node node = new76(); push(goTo(9), node, true); } break;
                    case 77: { Node node = new77(); push(goTo(10), node, true); } break;
                    case 78: { Node node = new78(); push(goTo(10), node, true); } break;
                    case 79: { Node node = new79(); push(goTo(10), node, true); } break;
                    case 80: { Node node = new80(); push(goTo(30), node, false); } break;
                    case 81: { Node node = new81(); push(goTo(30), node, false); } break;
                    case 82: { Node node = new82(); push(goTo(10), node, true); } break;
                    case 83: { Node node = new83(); push(goTo(10), node, true); } break;
                    case 84: { Node node = new84(); push(goTo(10), node, true); } break;
                    case 85: { Node node = new85(); push(goTo(31), node, false); } break;
                    case 86: { Node node = new86(); push(goTo(31), node, false); } break;
                    case 87: { Node node = new87(); push(goTo(10), node, true); } break;
                    case 88: { Node node = new88(); push(goTo(10), node, true); } break;
                    case 89: { Node node = new89(); push(goTo(11), node, true); } break;
                    case 90: { Node node = new90(); push(goTo(12), node, true); } break;
                    case 91: { Node node = new91(); push(goTo(12), node, true); } break;
                    case 92: { Node node = new92(); push(goTo(13), node, true); } break;
                    case 93: { Node node = new93(); push(goTo(13), node, true); } break;
                    case 94: { Node node = new94(); push(goTo(13), node, true); } break;
                    case 95: { Node node = new95(); push(goTo(13), node, true); } break;
                    case 96: { Node node = new96(); push(goTo(13), node, true); } break;
                    case 97: { Node node = new97(); push(goTo(13), node, true); } break;
                    case 98: { Node node = new98(); push(goTo(14), node, true); } break;
                    case 99: { Node node = new99(); push(goTo(14), node, true); } break;
                    case 100: { Node node = new100(); push(goTo(15), node, true); } break;
                    case 101: { Node node = new101(); push(goTo(15), node, true); } break;
                    case 102: { Node node = new102(); push(goTo(32), node, false); } break;
                    case 103: { Node node = new103(); push(goTo(32), node, false); } break;
                    case 104: { Node node = new104(); push(goTo(16), node, true); } break;
                    case 105: { Node node = new105(); push(goTo(17), node, true); } break;
                    case 106: { Node node = new106(); push(goTo(17), node, true); } break;
                    case 107: { Node node = new107(); push(goTo(33), node, false); } break;
                    case 108: { Node node = new108(); push(goTo(33), node, false); } break;
                    case 109: { Node node = new109(); push(goTo(18), node, true); } break;
                    case 110: { Node node = new110(); push(goTo(18), node, true); } break;
                    case 111: { Node node = new111(); push(goTo(19), node, true); } break;
                    case 112: { Node node = new112(); push(goTo(19), node, true); } break;
                    case 113: { Node node = new113(); push(goTo(34), node, false); } break;
                    case 114: { Node node = new114(); push(goTo(34), node, false); } break;
                    case 115: { Node node = new115(); push(goTo(20), node, true); } break;
                    case 116: { Node node = new116(); push(goTo(20), node, true); } break;
                    case 117: { Node node = new117(); push(goTo(20), node, true); } break;
                    case 118: { Node node = new118(); push(goTo(21), node, true); } break;
                    case 119: { Node node = new119(); push(goTo(21), node, true); } break;
                    case 120: { Node node = new120(); push(goTo(35), node, false); } break;
                    case 121: { Node node = new121(); push(goTo(35), node, false); } break;
                    case 122: { Node node = new122(); push(goTo(22), node, true); } break;
                    case 123: { Node node = new123(); push(goTo(23), node, true); } break;
                    case 124: { Node node = new124(); push(goTo(23), node, true); } break;
                    case 125: { Node node = new125(); push(goTo(23), node, true); } break;
                    case 126: { Node node = new126(); push(goTo(23), node, true); } break;
                    case 127: { Node node = new127(); push(goTo(24), node, true); } break;
                    case 128: { Node node = new128(); push(goTo(24), node, true); } break;
                    case 129: { Node node = new129(); push(goTo(36), node, false); } break;
                    case 130: { Node node = new130(); push(goTo(36), node, false); } break;
                    case 131: { Node node = new131(); push(goTo(25), node, true); } break;
                    case 132: { Node node = new132(); push(goTo(25), node, true); } break;
                    case 133: { Node node = new133(); push(goTo(37), node, false); } break;
                    case 134: { Node node = new134(); push(goTo(37), node, false); } break;
                    case 135: { Node node = new135(); push(goTo(26), node, true); } break;
                    case 136: { Node node = new136(); push(goTo(27), node, true); } break;
                    case 137: { Node node = new137(); push(goTo(27), node, true); } break;
                    case 138: { Node node = new138(); push(goTo(38), node, false); } break;
                    case 139: { Node node = new139(); push(goTo(38), node, false); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PExpr node1 = (PExpr) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PAndexpr node2 = (PAndexpr) pop();
        XPOrexprlist node1 = null;
        AExpr node = new AExpr(node1, node2);
        return node;
    }

    Node new1()
    {
        PAndexpr node2 = (PAndexpr) pop();
        XPOrexprlist node1 = (XPOrexprlist) pop();
        AExpr node = new AExpr(node1, node2);
        return node;
    }

    Node new2()
    {
        POrexprlist node2 = (POrexprlist) pop();
        XPOrexprlist node1 = (XPOrexprlist) pop();
        X1POrexprlist node = new X1POrexprlist(node1, node2);
        return node;
    }

    Node new3()
    {
        POrexprlist node1 = (POrexprlist) pop();
        X2POrexprlist node = new X2POrexprlist(node1);
        return node;
    }

    Node new4()
    {
        TAncestorTok node1 = (TAncestorTok) pop();
        AAncestorAxisname node = new AAncestorAxisname(node1);
        return node;
    }

    Node new5()
    {
        TAncestorOrSelfTok node1 = (TAncestorOrSelfTok) pop();
        AAncestorOrSelfAxisname node = new AAncestorOrSelfAxisname(node1);
        return node;
    }

    Node new6()
    {
        TAttributeTok node1 = (TAttributeTok) pop();
        AAttributeAxisname node = new AAttributeAxisname(node1);
        return node;
    }

    Node new7()
    {
        TChildTok node1 = (TChildTok) pop();
        AChildAxisname node = new AChildAxisname(node1);
        return node;
    }

    Node new8()
    {
        TDescendentTok node1 = (TDescendentTok) pop();
        ADescendentAxisname node = new ADescendentAxisname(node1);
        return node;
    }

    Node new9()
    {
        TDescendentOrSelfTok node1 = (TDescendentOrSelfTok) pop();
        ADescendentOrSelfAxisname node = new ADescendentOrSelfAxisname(node1);
        return node;
    }

    Node new10()
    {
        TFollowingTok node1 = (TFollowingTok) pop();
        AFollowingAxisname node = new AFollowingAxisname(node1);
        return node;
    }

    Node new11()
    {
        TFollowingSiblingTok node1 = (TFollowingSiblingTok) pop();
        AFollowingSiblingAxisname node = new AFollowingSiblingAxisname(node1);
        return node;
    }

    Node new12()
    {
        TNamespaceTok node1 = (TNamespaceTok) pop();
        ANamespaceAxisname node = new ANamespaceAxisname(node1);
        return node;
    }

    Node new13()
    {
        TParentTok node1 = (TParentTok) pop();
        AParentAxisname node = new AParentAxisname(node1);
        return node;
    }

    Node new14()
    {
        TPrecedingTok node1 = (TPrecedingTok) pop();
        APrecedingAxisname node = new APrecedingAxisname(node1);
        return node;
    }

    Node new15()
    {
        TPrecedingSiblingTok node1 = (TPrecedingSiblingTok) pop();
        APrecedingSiblingAxisname node = new APrecedingSiblingAxisname(node1);
        return node;
    }

    Node new16()
    {
        TSelfTok node1 = (TSelfTok) pop();
        ASelfAxisname node = new ASelfAxisname(node1);
        return node;
    }

    Node new17()
    {
        TNcnameTok node1 = (TNcnameTok) pop();
        ANcnameQname node = new ANcnameQname(node1);
        return node;
    }

    Node new18()
    {
        TNcnameTok node3 = (TNcnameTok) pop();
        TColonTok node2 = (TColonTok) pop();
        TNcnameTok node1 = (TNcnameTok) pop();
        AFullnameQname node = new AFullnameQname(node1, node2, node3);
        return node;
    }

    Node new19()
    {
        TKleeneTok node1 = (TKleeneTok) pop();
        AWildcardNametest node = new AWildcardNametest(node1);
        return node;
    }

    Node new20()
    {
        TKleeneTok node3 = (TKleeneTok) pop();
        TColonTok node2 = (TColonTok) pop();
        TNcnameTok node1 = (TNcnameTok) pop();
        AQualifiedWildcardNametest node = new AQualifiedWildcardNametest(node1, node2, node3);
        return node;
    }

    Node new21()
    {
        PQname node1 = (PQname) pop();
        AQnameNametest node = new AQnameNametest(node1);
        return node;
    }

    Node new22()
    {
        PNametest node1 = (PNametest) pop();
        ANametestNodetest node = new ANametestNodetest(node1);
        return node;
    }

    Node new23()
    {
        TRightParenTok node2 = (TRightParenTok) pop();
        TCommentTok node1 = (TCommentTok) pop();
        ACommentNodetest node = new ACommentNodetest(node1, node2);
        return node;
    }

    Node new24()
    {
        TRightParenTok node2 = (TRightParenTok) pop();
        TTextTok node1 = (TTextTok) pop();
        ATextNodetest node = new ATextNodetest(node1, node2);
        return node;
    }

    Node new25()
    {
        TRightParenTok node2 = (TRightParenTok) pop();
        TNodeTok node1 = (TNodeTok) pop();
        ANodeNodetest node = new ANodeNodetest(node1, node2);
        return node;
    }

    Node new26()
    {
        TRightParenTok node3 = (TRightParenTok) pop();
        TLiteralTok node2 = null;
        TProcessingInstructionTok node1 = (TProcessingInstructionTok) pop();
        AProcessingInstructionNodetest node = new AProcessingInstructionNodetest(node1, node2, node3);
        return node;
    }

    Node new27()
    {
        TRightParenTok node3 = (TRightParenTok) pop();
        TLiteralTok node2 = (TLiteralTok) pop();
        TProcessingInstructionTok node1 = (TProcessingInstructionTok) pop();
        AProcessingInstructionNodetest node = new AProcessingInstructionNodetest(node1, node2, node3);
        return node;
    }

    Node new28()
    {
        TAxisTok node2 = (TAxisTok) pop();
        PAxisname node1 = (PAxisname) pop();
        AFullAxisspecifier node = new AFullAxisspecifier(node1, node2);
        return node;
    }

    Node new29()
    {
        TAtSignTok node1 = (TAtSignTok) pop();
        AAttributeAxisspecifier node = new AAttributeAxisspecifier(node1);
        return node;
    }

    Node new30()
    {
        TLastTok node1 = (TLastTok) pop();
        ALastFunctionname node = new ALastFunctionname(node1);
        return node;
    }

    Node new31()
    {
        TPositionTok node1 = (TPositionTok) pop();
        APositionFunctionname node = new APositionFunctionname(node1);
        return node;
    }

    Node new32()
    {
        TCountTok node1 = (TCountTok) pop();
        ACountFunctionname node = new ACountFunctionname(node1);
        return node;
    }

    Node new33()
    {
        TLocalNameTok node1 = (TLocalNameTok) pop();
        ALocalNameFunctionname node = new ALocalNameFunctionname(node1);
        return node;
    }

    Node new34()
    {
        TNamespaceUriTok node1 = (TNamespaceUriTok) pop();
        ANamespaceUriFunctionname node = new ANamespaceUriFunctionname(node1);
        return node;
    }

    Node new35()
    {
        TStringTok node1 = (TStringTok) pop();
        AStringFunctionname node = new AStringFunctionname(node1);
        return node;
    }

    Node new36()
    {
        TNameTok node1 = (TNameTok) pop();
        ANameFunctionname node = new ANameFunctionname(node1);
        return node;
    }

    Node new37()
    {
        TConcatTok node1 = (TConcatTok) pop();
        AConcatFunctionname node = new AConcatFunctionname(node1);
        return node;
    }

    Node new38()
    {
        TStartsWithTok node1 = (TStartsWithTok) pop();
        AStartsWithFunctionname node = new AStartsWithFunctionname(node1);
        return node;
    }

    Node new39()
    {
        TContainsTok node1 = (TContainsTok) pop();
        AContainsFunctionname node = new AContainsFunctionname(node1);
        return node;
    }

    Node new40()
    {
        TSubstringBeforeTok node1 = (TSubstringBeforeTok) pop();
        ASubstringBeforeFunctionname node = new ASubstringBeforeFunctionname(node1);
        return node;
    }

    Node new41()
    {
        TSubstringAfterTok node1 = (TSubstringAfterTok) pop();
        ASubstringAfterFunctionname node = new ASubstringAfterFunctionname(node1);
        return node;
    }

    Node new42()
    {
        TSubstringTok node1 = (TSubstringTok) pop();
        ASubstringFunctionname node = new ASubstringFunctionname(node1);
        return node;
    }

    Node new43()
    {
        TStringLengthTok node1 = (TStringLengthTok) pop();
        AStringLengthFunctionname node = new AStringLengthFunctionname(node1);
        return node;
    }

    Node new44()
    {
        TNormalizeSpaceTok node1 = (TNormalizeSpaceTok) pop();
        ANormalizeSpaceFunctionname node = new ANormalizeSpaceFunctionname(node1);
        return node;
    }

    Node new45()
    {
        TTranslateTok node1 = (TTranslateTok) pop();
        ATranslateFunctionname node = new ATranslateFunctionname(node1);
        return node;
    }

    Node new46()
    {
        TBooleanTok node1 = (TBooleanTok) pop();
        ABooleanFunctionname node = new ABooleanFunctionname(node1);
        return node;
    }

    Node new47()
    {
        TNotTok node1 = (TNotTok) pop();
        ANotFunctionname node = new ANotFunctionname(node1);
        return node;
    }

    Node new48()
    {
        TTrueTok node1 = (TTrueTok) pop();
        ATrueFunctionname node = new ATrueFunctionname(node1);
        return node;
    }

    Node new49()
    {
        TFalseTok node1 = (TFalseTok) pop();
        AFalseFunctionname node = new AFalseFunctionname(node1);
        return node;
    }

    Node new50()
    {
        TLangTok node1 = (TLangTok) pop();
        ALangFunctionname node = new ALangFunctionname(node1);
        return node;
    }

    Node new51()
    {
        TNumberStringTok node1 = (TNumberStringTok) pop();
        ANumberStringFunctionname node = new ANumberStringFunctionname(node1);
        return node;
    }

    Node new52()
    {
        TSumTok node1 = (TSumTok) pop();
        ASumFunctionname node = new ASumFunctionname(node1);
        return node;
    }

    Node new53()
    {
        TFloorTok node1 = (TFloorTok) pop();
        AFloorFunctionname node = new AFloorFunctionname(node1);
        return node;
    }

    Node new54()
    {
        TCeilingTok node1 = (TCeilingTok) pop();
        ACeilingFunctionname node = new ACeilingFunctionname(node1);
        return node;
    }

    Node new55()
    {
        TRoundTok node1 = (TRoundTok) pop();
        ARoundFunctionname node = new ARoundFunctionname(node1);
        return node;
    }

    Node new56()
    {
        TDocumentTok node1 = (TDocumentTok) pop();
        ADocumentFunctionname node = new ADocumentFunctionname(node1);
        return node;
    }

    Node new57()
    {
        TKeyTok node1 = (TKeyTok) pop();
        AKeyFunctionname node = new AKeyFunctionname(node1);
        return node;
    }

    Node new58()
    {
        TIdTok node1 = (TIdTok) pop();
        AIdFunctionname node = new AIdFunctionname(node1);
        return node;
    }

    Node new59()
    {
        TFormatNumberTok node1 = (TFormatNumberTok) pop();
        AFormatNumberFunctionname node = new AFormatNumberFunctionname(node1);
        return node;
    }

    Node new60()
    {
        TCurrentTok node1 = (TCurrentTok) pop();
        ACurrentFunctionname node = new ACurrentFunctionname(node1);
        return node;
    }

    Node new61()
    {
        TUnparsedEntityUriTok node1 = (TUnparsedEntityUriTok) pop();
        AUnparsedEntityUriFunctionname node = new AUnparsedEntityUriFunctionname(node1);
        return node;
    }

    Node new62()
    {
        TGenerateIdTok node1 = (TGenerateIdTok) pop();
        AGenerateIdFunctionname node = new AGenerateIdFunctionname(node1);
        return node;
    }

    Node new63()
    {
        TFunctionAvailableTok node1 = (TFunctionAvailableTok) pop();
        AFunctionAvailableTokFunctionname node = new AFunctionAvailableTokFunctionname(node1);
        return node;
    }

    Node new64()
    {
        TElementAvailableTok node1 = (TElementAvailableTok) pop();
        AElementAvailableTokFunctionname node = new AElementAvailableTokFunctionname(node1);
        return node;
    }

    Node new65()
    {
        TSystemPropertyTok node1 = (TSystemPropertyTok) pop();
        ASystemPropertyFunctionname node = new ASystemPropertyFunctionname(node1);
        return node;
    }

    Node new66()
    {
        TCommaTok node2 = (TCommaTok) pop();
        PExpr node1 = (PExpr) pop();
        AExprlist node = new AExprlist(node1, node2);
        return node;
    }

    Node new67()
    {
        PExpr node2 = (PExpr) pop();
        XPExprlist node1 = null;
        AParameterlist node = new AParameterlist(node1, node2);
        return node;
    }

    Node new68()
    {
        PExpr node2 = (PExpr) pop();
        XPExprlist node1 = (XPExprlist) pop();
        AParameterlist node = new AParameterlist(node1, node2);
        return node;
    }

    Node new69()
    {
        PExprlist node2 = (PExprlist) pop();
        XPExprlist node1 = (XPExprlist) pop();
        X1PExprlist node = new X1PExprlist(node1, node2);
        return node;
    }

    Node new70()
    {
        PExprlist node1 = (PExprlist) pop();
        X2PExprlist node = new X2PExprlist(node1);
        return node;
    }

    Node new71()
    {
        PQname node2 = (PQname) pop();
        TDollarTok node1 = (TDollarTok) pop();
        AVariableFilterexpr node = new AVariableFilterexpr(node1, node2);
        return node;
    }

    Node new72()
    {
        TRightParenTok node3 = (TRightParenTok) pop();
        PExpr node2 = (PExpr) pop();
        TLeftParenTok node1 = (TLeftParenTok) pop();
        AParethesisExprFilterexpr node = new AParethesisExprFilterexpr(node1, node2, node3);
        return node;
    }

    Node new73()
    {
        TLiteralTok node1 = (TLiteralTok) pop();
        ALiteralFilterexpr node = new ALiteralFilterexpr(node1);
        return node;
    }

    Node new74()
    {
        TNumberTok node1 = (TNumberTok) pop();
        ANumberFilterexpr node = new ANumberFilterexpr(node1);
        return node;
    }

    Node new75()
    {
        TRightParenTok node3 = (TRightParenTok) pop();
        PParameterlist node2 = null;
        PFunctionname node1 = (PFunctionname) pop();
        AFunctioncallFilterexpr node = new AFunctioncallFilterexpr(node1, node2, node3);
        return node;
    }

    Node new76()
    {
        TRightParenTok node3 = (TRightParenTok) pop();
        PParameterlist node2 = (PParameterlist) pop();
        PFunctionname node1 = (PFunctionname) pop();
        AFunctioncallFilterexpr node = new AFunctioncallFilterexpr(node1, node2, node3);
        return node;
    }

    Node new77()
    {
        TSlashTok node1 = (TSlashTok) pop();
        ARootPathexpr node = new ARootPathexpr(node1);
        return node;
    }

    Node new78()
    {
        XPNextStep node2 = null;
        PStep node1 = (PStep) pop();
        ARelativePathexpr node = new ARelativePathexpr(node1, node2);
        return node;
    }

    Node new79()
    {
        XPNextStep node2 = (XPNextStep) pop();
        PStep node1 = (PStep) pop();
        ARelativePathexpr node = new ARelativePathexpr(node1, node2);
        return node;
    }

    Node new80()
    {
        PNextStep node2 = (PNextStep) pop();
        XPNextStep node1 = (XPNextStep) pop();
        X1PNextStep node = new X1PNextStep(node1, node2);
        return node;
    }

    Node new81()
    {
        PNextStep node1 = (PNextStep) pop();
        X2PNextStep node = new X2PNextStep(node1);
        return node;
    }

    Node new82()
    {
        XPNextStep node1 = (XPNextStep) pop();
        AAbsolutePathexpr node = new AAbsolutePathexpr(node1);
        return node;
    }

    Node new83()
    {
        XPNextStep node3 = null;
        XPPredicate node2 = null;
        PFilterexpr node1 = (PFilterexpr) pop();
        AFilterFromRootPathPathexpr node = new AFilterFromRootPathPathexpr(node1, node2, node3);
        return node;
    }

    Node new84()
    {
        XPNextStep node3 = null;
        XPPredicate node2 = (XPPredicate) pop();
        PFilterexpr node1 = (PFilterexpr) pop();
        AFilterFromRootPathPathexpr node = new AFilterFromRootPathPathexpr(node1, node2, node3);
        return node;
    }

    Node new85()
    {
        PPredicate node2 = (PPredicate) pop();
        XPPredicate node1 = (XPPredicate) pop();
        X1PPredicate node = new X1PPredicate(node1, node2);
        return node;
    }

    Node new86()
    {
        PPredicate node1 = (PPredicate) pop();
        X2PPredicate node = new X2PPredicate(node1);
        return node;
    }

    Node new87()
    {
        XPNextStep node3 = (XPNextStep) pop();
        XPPredicate node2 = null;
        PFilterexpr node1 = (PFilterexpr) pop();
        AFilterFromRootPathPathexpr node = new AFilterFromRootPathPathexpr(node1, node2, node3);
        return node;
    }

    Node new88()
    {
        XPNextStep node3 = (XPNextStep) pop();
        XPPredicate node2 = (XPPredicate) pop();
        PFilterexpr node1 = (PFilterexpr) pop();
        AFilterFromRootPathPathexpr node = new AFilterFromRootPathPathexpr(node1, node2, node3);
        return node;
    }

    Node new89()
    {
        TRightSquareTok node3 = (TRightSquareTok) pop();
        PExpr node2 = (PExpr) pop();
        TLeftSquareTok node1 = (TLeftSquareTok) pop();
        APredicate node = new APredicate(node1, node2, node3);
        return node;
    }

    Node new90()
    {
        PStep node2 = (PStep) pop();
        TDoubleslashTok node1 = (TDoubleslashTok) pop();
        ADescendentNextStep node = new ADescendentNextStep(node1, node2);
        return node;
    }

    Node new91()
    {
        PStep node2 = (PStep) pop();
        TSlashTok node1 = (TSlashTok) pop();
        AChildNextStep node = new AChildNextStep(node1, node2);
        return node;
    }

    Node new92()
    {
        XPPredicate node3 = null;
        PNodetest node2 = (PNodetest) pop();
        PAxisspecifier node1 = null;
        AFullStep node = new AFullStep(node1, node2, node3);
        return node;
    }

    Node new93()
    {
        XPPredicate node3 = null;
        PNodetest node2 = (PNodetest) pop();
        PAxisspecifier node1 = (PAxisspecifier) pop();
        AFullStep node = new AFullStep(node1, node2, node3);
        return node;
    }

    Node new94()
    {
        XPPredicate node3 = (XPPredicate) pop();
        PNodetest node2 = (PNodetest) pop();
        PAxisspecifier node1 = null;
        AFullStep node = new AFullStep(node1, node2, node3);
        return node;
    }

    Node new95()
    {
        XPPredicate node3 = (XPPredicate) pop();
        PNodetest node2 = (PNodetest) pop();
        PAxisspecifier node1 = (PAxisspecifier) pop();
        AFullStep node = new AFullStep(node1, node2, node3);
        return node;
    }

    Node new96()
    {
        TDotTok node1 = (TDotTok) pop();
        ACurrentStep node = new ACurrentStep(node1);
        return node;
    }

    Node new97()
    {
        TDoubledotTok node1 = (TDoubledotTok) pop();
        AParentStep node = new AParentStep(node1);
        return node;
    }

    Node new98()
    {
        TPlusTok node2 = (TPlusTok) pop();
        PMulexpr node1 = (PMulexpr) pop();
        AAdditionAddexprlist node = new AAdditionAddexprlist(node1, node2);
        return node;
    }

    Node new99()
    {
        TMinusTok node2 = (TMinusTok) pop();
        PMulexpr node1 = (PMulexpr) pop();
        ASubtractionAddexprlist node = new ASubtractionAddexprlist(node1, node2);
        return node;
    }

    Node new100()
    {
        PMulexpr node2 = (PMulexpr) pop();
        XPAddexprlist node1 = null;
        AAddexpr node = new AAddexpr(node1, node2);
        return node;
    }

    Node new101()
    {
        PMulexpr node2 = (PMulexpr) pop();
        XPAddexprlist node1 = (XPAddexprlist) pop();
        AAddexpr node = new AAddexpr(node1, node2);
        return node;
    }

    Node new102()
    {
        PAddexprlist node2 = (PAddexprlist) pop();
        XPAddexprlist node1 = (XPAddexprlist) pop();
        X1PAddexprlist node = new X1PAddexprlist(node1, node2);
        return node;
    }

    Node new103()
    {
        PAddexprlist node1 = (PAddexprlist) pop();
        X2PAddexprlist node = new X2PAddexprlist(node1);
        return node;
    }

    Node new104()
    {
        TAndTok node2 = (TAndTok) pop();
        PEqexpr node1 = (PEqexpr) pop();
        AAndexprlist node = new AAndexprlist(node1, node2);
        return node;
    }

    Node new105()
    {
        PEqexpr node2 = (PEqexpr) pop();
        XPAndexprlist node1 = null;
        AAndexpr node = new AAndexpr(node1, node2);
        return node;
    }

    Node new106()
    {
        PEqexpr node2 = (PEqexpr) pop();
        XPAndexprlist node1 = (XPAndexprlist) pop();
        AAndexpr node = new AAndexpr(node1, node2);
        return node;
    }

    Node new107()
    {
        PAndexprlist node2 = (PAndexprlist) pop();
        XPAndexprlist node1 = (XPAndexprlist) pop();
        X1PAndexprlist node = new X1PAndexprlist(node1, node2);
        return node;
    }

    Node new108()
    {
        PAndexprlist node1 = (PAndexprlist) pop();
        X2PAndexprlist node = new X2PAndexprlist(node1);
        return node;
    }

    Node new109()
    {
        TEqualTok node2 = (TEqualTok) pop();
        PRelationalexpr node1 = (PRelationalexpr) pop();
        AEqualEqexprlist node = new AEqualEqexprlist(node1, node2);
        return node;
    }

    Node new110()
    {
        TNotEqualTok node2 = (TNotEqualTok) pop();
        PRelationalexpr node1 = (PRelationalexpr) pop();
        ANotequalEqexprlist node = new ANotequalEqexprlist(node1, node2);
        return node;
    }

    Node new111()
    {
        PRelationalexpr node2 = (PRelationalexpr) pop();
        XPEqexprlist node1 = null;
        AEqexpr node = new AEqexpr(node1, node2);
        return node;
    }

    Node new112()
    {
        PRelationalexpr node2 = (PRelationalexpr) pop();
        XPEqexprlist node1 = (XPEqexprlist) pop();
        AEqexpr node = new AEqexpr(node1, node2);
        return node;
    }

    Node new113()
    {
        PEqexprlist node2 = (PEqexprlist) pop();
        XPEqexprlist node1 = (XPEqexprlist) pop();
        X1PEqexprlist node = new X1PEqexprlist(node1, node2);
        return node;
    }

    Node new114()
    {
        PEqexprlist node1 = (PEqexprlist) pop();
        X2PEqexprlist node = new X2PEqexprlist(node1);
        return node;
    }

    Node new115()
    {
        TStarTok node2 = (TStarTok) pop();
        PUnaryexpr node1 = (PUnaryexpr) pop();
        AMulMulexprlist node = new AMulMulexprlist(node1, node2);
        return node;
    }

    Node new116()
    {
        TDivTok node2 = (TDivTok) pop();
        PUnaryexpr node1 = (PUnaryexpr) pop();
        ADivMulexprlist node = new ADivMulexprlist(node1, node2);
        return node;
    }

    Node new117()
    {
        TModTok node2 = (TModTok) pop();
        PUnaryexpr node1 = (PUnaryexpr) pop();
        AModMulexprlist node = new AModMulexprlist(node1, node2);
        return node;
    }

    Node new118()
    {
        PUnaryexpr node2 = (PUnaryexpr) pop();
        XPMulexprlist node1 = null;
        AMulexpr node = new AMulexpr(node1, node2);
        return node;
    }

    Node new119()
    {
        PUnaryexpr node2 = (PUnaryexpr) pop();
        XPMulexprlist node1 = (XPMulexprlist) pop();
        AMulexpr node = new AMulexpr(node1, node2);
        return node;
    }

    Node new120()
    {
        PMulexprlist node2 = (PMulexprlist) pop();
        XPMulexprlist node1 = (XPMulexprlist) pop();
        X1PMulexprlist node = new X1PMulexprlist(node1, node2);
        return node;
    }

    Node new121()
    {
        PMulexprlist node1 = (PMulexprlist) pop();
        X2PMulexprlist node = new X2PMulexprlist(node1);
        return node;
    }

    Node new122()
    {
        TOrTok node2 = (TOrTok) pop();
        PAndexpr node1 = (PAndexpr) pop();
        AOrexprlist node = new AOrexprlist(node1, node2);
        return node;
    }

    Node new123()
    {
        TLessTok node2 = (TLessTok) pop();
        PAddexpr node1 = (PAddexpr) pop();
        ALessRelationalexprlist node = new ALessRelationalexprlist(node1, node2);
        return node;
    }

    Node new124()
    {
        TGreaterTok node2 = (TGreaterTok) pop();
        PAddexpr node1 = (PAddexpr) pop();
        AGreaterRelationalexprlist node = new AGreaterRelationalexprlist(node1, node2);
        return node;
    }

    Node new125()
    {
        TLessEqualTok node2 = (TLessEqualTok) pop();
        PAddexpr node1 = (PAddexpr) pop();
        ALessEqualRelationalexprlist node = new ALessEqualRelationalexprlist(node1, node2);
        return node;
    }

    Node new126()
    {
        TGreaterEqualTok node2 = (TGreaterEqualTok) pop();
        PAddexpr node1 = (PAddexpr) pop();
        AGreaterEqualRelationalexprlist node = new AGreaterEqualRelationalexprlist(node1, node2);
        return node;
    }

    Node new127()
    {
        PAddexpr node2 = (PAddexpr) pop();
        XPRelationalexprlist node1 = null;
        ARelationalexpr node = new ARelationalexpr(node1, node2);
        return node;
    }

    Node new128()
    {
        PAddexpr node2 = (PAddexpr) pop();
        XPRelationalexprlist node1 = (XPRelationalexprlist) pop();
        ARelationalexpr node = new ARelationalexpr(node1, node2);
        return node;
    }

    Node new129()
    {
        PRelationalexprlist node2 = (PRelationalexprlist) pop();
        XPRelationalexprlist node1 = (XPRelationalexprlist) pop();
        X1PRelationalexprlist node = new X1PRelationalexprlist(node1, node2);
        return node;
    }

    Node new130()
    {
        PRelationalexprlist node1 = (PRelationalexprlist) pop();
        X2PRelationalexprlist node = new X2PRelationalexprlist(node1);
        return node;
    }

    Node new131()
    {
        PUnionexpr node2 = (PUnionexpr) pop();
        XTMinusTok node1 = null;
        AUnaryexpr node = new AUnaryexpr(node1, node2);
        return node;
    }

    Node new132()
    {
        PUnionexpr node2 = (PUnionexpr) pop();
        XTMinusTok node1 = (XTMinusTok) pop();
        AUnaryexpr node = new AUnaryexpr(node1, node2);
        return node;
    }

    Node new133()
    {
        TMinusTok node2 = (TMinusTok) pop();
        XTMinusTok node1 = (XTMinusTok) pop();
        X1TMinusTok node = new X1TMinusTok(node1, node2);
        return node;
    }

    Node new134()
    {
        TMinusTok node1 = (TMinusTok) pop();
        X2TMinusTok node = new X2TMinusTok(node1);
        return node;
    }

    Node new135()
    {
        TBarTok node2 = (TBarTok) pop();
        PPathexpr node1 = (PPathexpr) pop();
        AUnionexprlist node = new AUnionexprlist(node1, node2);
        return node;
    }

    Node new136()
    {
        PPathexpr node2 = (PPathexpr) pop();
        XPUnionexprlist node1 = null;
        AUnionexpr node = new AUnionexpr(node1, node2);
        return node;
    }

    Node new137()
    {
        PPathexpr node2 = (PPathexpr) pop();
        XPUnionexprlist node1 = (XPUnionexprlist) pop();
        AUnionexpr node = new AUnionexpr(node1, node2);
        return node;
    }

    Node new138()
    {
        PUnionexprlist node2 = (PUnionexprlist) pop();
        XPUnionexprlist node1 = (XPUnionexprlist) pop();
        X1PUnionexprlist node = new X1PUnionexprlist(node1, node2);
        return node;
    }

    Node new139()
    {
        PUnionexprlist node1 = (PUnionexprlist) pop();
        X2PUnionexprlist node = new X2PUnionexprlist(node1);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, ERROR, 1}, {61, SHIFT, 100}, {62, SHIFT, 101}, },
			{{-1, REDUCE, 61}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 63}, },
			{{-1, REDUCE, 11}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 64}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 41}, },
			{{-1, REDUCE, 44}, },
			{{-1, REDUCE, 65}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 34}, },
			{{-1, REDUCE, 59}, },
			{{-1, REDUCE, 51}, },
			{{-1, REDUCE, 62}, },
			{{-1, REDUCE, 38}, },
			{{-1, REDUCE, 8}, },
			{{-1, REDUCE, 33}, },
			{{-1, REDUCE, 12}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 45}, },
			{{-1, REDUCE, 42}, },
			{{-1, REDUCE, 6}, },
			{{-1, REDUCE, 56}, },
			{{-1, REDUCE, 39}, },
			{{-1, REDUCE, 31}, },
			{{-1, REDUCE, 4}, },
			{{-1, REDUCE, 54}, },
			{{-1, REDUCE, 60}, },
			{{-1, ERROR, 33}, {61, SHIFT, 102}, },
			{{-1, REDUCE, 46}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 35}, },
			{{-1, REDUCE, 37}, },
			{{-1, REDUCE, 32}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 53}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 30}, },
			{{-1, REDUCE, 48}, },
			{{-1, REDUCE, 36}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 48}, {61, SHIFT, 103}, },
			{{-1, ERROR, 49}, {61, SHIFT, 104}, },
			{{-1, REDUCE, 57}, },
			{{-1, REDUCE, 47}, },
			{{-1, REDUCE, 52}, },
			{{-1, REDUCE, 58}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 55}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 73}, },
			{{-1, REDUCE, 74}, },
			{{-1, REDUCE, 29}, },
			{{-1, ERROR, 59}, {83, SHIFT, 106}, },
			{{-1, ERROR, 60}, {0, SHIFT, 1}, {2, SHIFT, 3}, {4, SHIFT, 5}, {5, SHIFT, 6}, {8, SHIFT, 9}, {18, SHIFT, 19}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {25, SHIFT, 26}, {29, SHIFT, 30}, {32, SHIFT, 33}, {34, SHIFT, 35}, {41, SHIFT, 42}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {58, SHIFT, 54}, {64, SHIFT, 58}, {71, SHIFT, 62}, {72, SHIFT, 63}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 77}, {0, SHIFT, 1}, {2, SHIFT, 3}, {4, SHIFT, 5}, {5, SHIFT, 6}, {8, SHIFT, 9}, {18, SHIFT, 19}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {25, SHIFT, 26}, {29, SHIFT, 30}, {32, SHIFT, 33}, {34, SHIFT, 35}, {41, SHIFT, 42}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {58, SHIFT, 54}, {64, SHIFT, 58}, {71, SHIFT, 62}, {72, SHIFT, 63}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 96}, },
			{{-1, REDUCE, 97}, },
			{{-1, REDUCE, 134}, },
			{{-1, REDUCE, 17}, {57, SHIFT, 110}, },
			{{-1, ERROR, 66}, {84, ACCEPT, -1}, },
			{{-1, ERROR, 67}, {56, SHIFT, 111}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 92}, {69, SHIFT, 112}, },
			{{-1, ERROR, 71}, {0, SHIFT, 1}, {32, SHIFT, 33}, {47, SHIFT, 48}, {48, SHIFT, 49}, {58, SHIFT, 54}, {83, SHIFT, 65}, },
			{{-1, ERROR, 72}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {61, SHIFT, 116}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 83}, {67, SHIFT, 60}, {68, SHIFT, 121}, {69, SHIFT, 112}, },
			{{-1, REDUCE, 136}, {73, SHIFT, 124}, },
			{{-1, REDUCE, 81}, },
			{{-1, REDUCE, 78}, {67, SHIFT, 60}, {68, SHIFT, 121}, },
			{{-1, REDUCE, 103}, },
			{{-1, REDUCE, 127}, {79, SHIFT, 126}, {80, SHIFT, 127}, {81, SHIFT, 128}, {82, SHIFT, 129}, },
			{{-1, REDUCE, 108}, },
			{{-1, REDUCE, 0}, {78, SHIFT, 130}, },
			{{-1, REDUCE, 114}, },
			{{-1, REDUCE, 105}, {50, SHIFT, 131}, },
			{{-1, REDUCE, 121}, },
			{{-1, REDUCE, 100}, {74, SHIFT, 132}, {75, SHIFT, 133}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 130}, },
			{{-1, REDUCE, 111}, {76, SHIFT, 134}, {77, SHIFT, 135}, },
			{{-1, REDUCE, 118}, {51, SHIFT, 136}, {52, SHIFT, 137}, {59, SHIFT, 138}, },
			{{-1, REDUCE, 139}, },
			{{-1, REDUCE, 131}, },
			{{-1, ERROR, 91}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 82}, {67, SHIFT, 60}, {68, SHIFT, 121}, },
			{{-1, ERROR, 93}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, ERROR, 94}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, ERROR, 95}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, ERROR, 96}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, ERROR, 97}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, ERROR, 98}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 152}, {83, SHIFT, 65}, },
			{{-1, ERROR, 99}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 101}, {61, SHIFT, 156}, },
			{{-1, REDUCE, 23}, },
			{{-1, REDUCE, 24}, },
			{{-1, REDUCE, 25}, },
			{{-1, ERROR, 105}, {61, SHIFT, 157}, },
			{{-1, REDUCE, 17}, {57, SHIFT, 158}, },
			{{-1, REDUCE, 71}, },
			{{-1, REDUCE, 90}, },
			{{-1, REDUCE, 91}, },
			{{-1, ERROR, 110}, {58, SHIFT, 159}, {83, SHIFT, 160}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 112}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 86}, },
			{{-1, REDUCE, 94}, {69, SHIFT, 112}, },
			{{-1, REDUCE, 93}, {69, SHIFT, 112}, },
			{{-1, REDUCE, 75}, },
			{{-1, REDUCE, 67}, {66, SHIFT, 164}, },
			{{-1, REDUCE, 70}, },
			{{-1, ERROR, 119}, {61, SHIFT, 165}, },
			{{-1, ERROR, 120}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {11, SHIFT, 12}, {12, SHIFT, 13}, {13, SHIFT, 14}, {14, SHIFT, 15}, {15, SHIFT, 16}, {16, SHIFT, 17}, {17, SHIFT, 18}, {18, SHIFT, 19}, {19, SHIFT, 20}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {23, SHIFT, 24}, {24, SHIFT, 25}, {25, SHIFT, 26}, {26, SHIFT, 27}, {27, SHIFT, 28}, {28, SHIFT, 29}, {29, SHIFT, 30}, {30, SHIFT, 31}, {31, SHIFT, 32}, {32, SHIFT, 33}, {33, SHIFT, 34}, {34, SHIFT, 35}, {35, SHIFT, 36}, {36, SHIFT, 37}, {37, SHIFT, 38}, {38, SHIFT, 39}, {39, SHIFT, 40}, {40, SHIFT, 41}, {41, SHIFT, 42}, {42, SHIFT, 43}, {43, SHIFT, 44}, {44, SHIFT, 45}, {45, SHIFT, 46}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {49, SHIFT, 50}, {53, SHIFT, 51}, {54, SHIFT, 52}, {55, SHIFT, 53}, {58, SHIFT, 54}, {60, SHIFT, 55}, {62, SHIFT, 56}, {63, SHIFT, 57}, {64, SHIFT, 58}, {65, SHIFT, 59}, {67, SHIFT, 60}, {68, SHIFT, 61}, {71, SHIFT, 62}, {72, SHIFT, 63}, {75, SHIFT, 64}, {83, SHIFT, 65}, },
			{{-1, ERROR, 121}, {0, SHIFT, 1}, {2, SHIFT, 3}, {4, SHIFT, 5}, {5, SHIFT, 6}, {8, SHIFT, 9}, {18, SHIFT, 19}, {20, SHIFT, 21}, {21, SHIFT, 22}, {22, SHIFT, 23}, {25, SHIFT, 26}, {29, SHIFT, 30}, {32, SHIFT, 33}, {34, SHIFT, 35}, {41, SHIFT, 42}, {46, SHIFT, 47}, {47, SHIFT, 48}, {48, SHIFT, 49}, {58, SHIFT, 54}, {64, SHIFT, 58}, {71, SHIFT, 62}, {72, SHIFT, 63}, {83, SHIFT, 65}, },
			{{-1, REDUCE, 87}, {67, SHIFT, 60}, {68, SHIFT, 121}, },
			{{-1, REDUCE, 84}, {67, SHIFT, 60}, {68, SHIFT, 121}, {69, SHIFT, 112}, },
			{{-1, REDUCE, 135}, },
			{{-1, REDUCE, 79}, {67, SHIFT, 60}, {68, SHIFT, 121}, },
			{{-1, REDUCE, 123}, },
			{{-1, REDUCE, 124}, },
			{{-1, REDUCE, 125}, },
			{{-1, REDUCE, 126}, },
			{{-1, REDUCE, 122}, },
			{{-1, REDUCE, 104}, },
			{{-1, REDUCE, 98}, },
			{{-1, REDUCE, 99}, },
			{{-1, REDUCE, 109}, },
			{{-1, REDUCE, 110}, },
			{{-1, REDUCE, 116}, },
			{{-1, REDUCE, 117}, },
			{{-1, REDUCE, 115}, },
			{{-1, REDUCE, 1}, {78, SHIFT, 130}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 80}, },
			{{-1, REDUCE, 102}, },
			{{-1, REDUCE, 101}, {74, SHIFT, 132}, {75, SHIFT, 133}, },
			{{-1, REDUCE, 107}, },
			{{-1, REDUCE, 106}, {50, SHIFT, 131}, },
			{{-1, REDUCE, 113}, },
			{{-1, REDUCE, 112}, {76, SHIFT, 134}, {77, SHIFT, 135}, },
			{{-1, REDUCE, 120}, },
			{{-1, REDUCE, 119}, {51, SHIFT, 136}, {52, SHIFT, 137}, {59, SHIFT, 138}, },
			{{-1, REDUCE, 128}, {79, SHIFT, 126}, {80, SHIFT, 127}, {81, SHIFT, 128}, {82, SHIFT, 129}, },
			{{-1, REDUCE, 129}, },
			{{-1, REDUCE, 133}, },
			{{-1, REDUCE, 132}, },
			{{-1, REDUCE, 137}, {73, SHIFT, 124}, },
			{{-1, REDUCE, 138}, },
			{{-1, REDUCE, 27}, },
			{{-1, REDUCE, 72}, },
			{{-1, ERROR, 158}, {83, SHIFT, 160}, },
			{{-1, REDUCE, 20}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 161}, {70, SHIFT, 169}, },
			{{-1, REDUCE, 85}, },
			{{-1, REDUCE, 95}, {69, SHIFT, 112}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 76}, },
			{{-1, REDUCE, 68}, {66, SHIFT, 164}, },
			{{-1, REDUCE, 69}, },
			{{-1, REDUCE, 88}, {67, SHIFT, 60}, {68, SHIFT, 121}, },
			{{-1, REDUCE, 89}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 66}, {55, 105}, {72, 117}, {112, 161}, {120, 166}, },
			{{-1, 67}, },
			{{-1, 68}, {59, 107}, },
			{{-1, 69}, },
			{{-1, 70}, {71, 115}, },
			{{-1, 71}, },
			{{-1, 72}, },
			{{-1, 118}, {120, 167}, },
			{{-1, 119}, },
			{{-1, 73}, },
			{{-1, 74}, {99, 154}, },
			{{-1, 113}, {114, 162}, {123, 162}, {163, 162}, },
			{{-1, 75}, {92, 141}, {122, 141}, {125, 141}, {168, 141}, },
			{{-1, 76}, {60, 108}, {61, 109}, {121, 109}, },
			{{-1, 77}, {93, 142}, },
			{{-1, 78}, {97, 150}, },
			{{-1, 79}, {94, 144}, },
			{{-1, 80}, {91, 139}, },
			{{-1, 81}, {95, 146}, },
			{{-1, 82}, {94, 145}, },
			{{-1, 83}, {96, 148}, },
			{{-1, 84}, {93, 143}, },
			{{-1, 85}, {91, 140}, },
			{{-1, 86}, {97, 151}, },
			{{-1, 87}, {95, 147}, },
			{{-1, 88}, {96, 149}, },
			{{-1, 89}, {99, 155}, },
			{{-1, 90}, {98, 153}, },
			{{-1, 91}, },
			{{-1, 120}, },
			{{-1, 92}, {73, 122}, {76, 125}, {123, 168}, },
			{{-1, 114}, {73, 123}, {115, 163}, },
			{{-1, 93}, },
			{{-1, 94}, },
			{{-1, 95}, },
			{{-1, 96}, },
			{{-1, 97}, },
			{{-1, 98}, },
			{{-1, 99}, },
        };*/
    private static String[] errorMessages;
/*      {
			"TProcessingInstructionTok TUnparsedEntityUriTok TDescendentOrSelfTok TFunctionAvailableTok TFollowingSiblingTok TPrecedingSiblingTok TElementAvailableTok TSubstringBeforeTok TAncestorOrSelfTok TSubstringAfterTok TNormalizeSpaceTok TSystemPropertyTok TStringLengthTok TNamespaceUriTok TFormatNumberTok TNumberStringTok TGenerateIdTok TStartsWithTok TDescendentTok TLocalNameTok TNamespaceTok TFollowingTok TPrecedingTok TTranslateTok TSubstringTok TAttributeTok TDocumentTok TContainsTok TPositionTok TAncestorTok TCeilingTok TCurrentTok TCommentTok TBooleanTok TParentTok TStringTok TConcatTok TCountTok TFalseTok TRoundTok TFloorTok TChildTok TLastTok TTrueTok TNameTok TLangTok TSelfTok TTextTok TNodeTok TKeyTok TNotTok TSumTok TIdTok TKleeneTok TLeftParenTok TLiteralTok TNumberTok TAtSignTok TDollarTok TDoubleslashTok TSlashTok TDotTok TDoubledotTok TMinusTok TNcnameTok expected.",
			"TRightParenTok TLiteralTok expected.",
			"TProcessingInstructionTok TUnparsedEntityUriTok TDescendentOrSelfTok TFunctionAvailableTok TFollowingSiblingTok TPrecedingSiblingTok TElementAvailableTok TSubstringBeforeTok TAncestorOrSelfTok TSubstringAfterTok TNormalizeSpaceTok TSystemPropertyTok TStringLengthTok TNamespaceUriTok TFormatNumberTok TNumberStringTok TGenerateIdTok TStartsWithTok TDescendentTok TLocalNameTok TNamespaceTok TFollowingTok TPrecedingTok TTranslateTok TSubstringTok TAttributeTok TDocumentTok TContainsTok TPositionTok TAncestorTok TCeilingTok TCurrentTok TCommentTok TBooleanTok TParentTok TStringTok TConcatTok TCountTok TFalseTok TRoundTok TFloorTok TChildTok TLastTok TTrueTok TNameTok TLangTok TSelfTok TTextTok TNodeTok TKeyTok TNotTok TSumTok TIdTok TKleeneTok TLeftParenTok TRightParenTok TLiteralTok TNumberTok TAtSignTok TDollarTok TDoubleslashTok TSlashTok TDotTok TDoubledotTok TMinusTok TNcnameTok expected.",
			"TAxisTok expected.",
			"TRightParenTok expected.",
			"TAndTok TDivTok TModTok TStarTok TRightParenTok TCommaTok TDoubleslashTok TSlashTok TLeftSquareTok TRightSquareTok TBarTok TPlusTok TMinusTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok EOF expected.",
			"TProcessingInstructionTok TCommentTok TTextTok TNodeTok TKleeneTok TNcnameTok expected.",
			"TNcnameTok expected.",
			"TProcessingInstructionTok TDescendentOrSelfTok TFollowingSiblingTok TPrecedingSiblingTok TAncestorOrSelfTok TDescendentTok TNamespaceTok TFollowingTok TPrecedingTok TAttributeTok TAncestorTok TCommentTok TParentTok TChildTok TSelfTok TTextTok TNodeTok TKleeneTok TAtSignTok TDotTok TDoubledotTok TNcnameTok expected.",
			"TProcessingInstructionTok TDescendentOrSelfTok TFollowingSiblingTok TPrecedingSiblingTok TAncestorOrSelfTok TDescendentTok TNamespaceTok TFollowingTok TPrecedingTok TAttributeTok TAncestorTok TCommentTok TParentTok TChildTok TSelfTok TTextTok TNodeTok TAndTok TDivTok TModTok TKleeneTok TStarTok TRightParenTok TAtSignTok TCommaTok TRightSquareTok TDotTok TDoubledotTok TBarTok TPlusTok TMinusTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok TNcnameTok EOF expected.",
			"TAndTok TDivTok TModTok TStarTok TRightParenTok TCommaTok TDoubleslashTok TSlashTok TRightSquareTok TBarTok TPlusTok TMinusTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok EOF expected.",
			"TAndTok TDivTok TModTok TColonTok TStarTok TRightParenTok TCommaTok TDoubleslashTok TSlashTok TLeftSquareTok TRightSquareTok TBarTok TPlusTok TMinusTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok EOF expected.",
			"EOF expected.",
			"TAndTok TDivTok TModTok TStarTok TRightParenTok TCommaTok TRightSquareTok TBarTok TPlusTok TMinusTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok EOF expected.",
			"TAndTok TRightParenTok TCommaTok TRightSquareTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok EOF expected.",
			"TRightParenTok TCommaTok TRightSquareTok TOrTok EOF expected.",
			"TAndTok TRightParenTok TCommaTok TRightSquareTok TOrTok EOF expected.",
			"TAndTok TRightParenTok TCommaTok TRightSquareTok TPlusTok TMinusTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok EOF expected.",
			"TAndTok TRightParenTok TCommaTok TRightSquareTok TEqualTok TNotEqualTok TOrTok EOF expected.",
			"TAndTok TDivTok TModTok TStarTok TRightParenTok TCommaTok TRightSquareTok TPlusTok TMinusTok TEqualTok TNotEqualTok TOrTok TLessTok TGreaterTok TLessEqualTok TGreaterEqualTok EOF expected.",
			"TProcessingInstructionTok TUnparsedEntityUriTok TDescendentOrSelfTok TFunctionAvailableTok TFollowingSiblingTok TPrecedingSiblingTok TElementAvailableTok TSubstringBeforeTok TAncestorOrSelfTok TSubstringAfterTok TNormalizeSpaceTok TSystemPropertyTok TStringLengthTok TNamespaceUriTok TFormatNumberTok TNumberStringTok TGenerateIdTok TStartsWithTok TDescendentTok TLocalNameTok TNamespaceTok TFollowingTok TPrecedingTok TTranslateTok TSubstringTok TAttributeTok TDocumentTok TContainsTok TPositionTok TAncestorTok TCeilingTok TCurrentTok TCommentTok TBooleanTok TParentTok TStringTok TConcatTok TCountTok TFalseTok TRoundTok TFloorTok TChildTok TLastTok TTrueTok TNameTok TLangTok TSelfTok TTextTok TNodeTok TKeyTok TNotTok TSumTok TIdTok TKleeneTok TLeftParenTok TLiteralTok TNumberTok TAtSignTok TDollarTok TDoubleslashTok TSlashTok TDotTok TDoubledotTok TNcnameTok expected.",
			"TKleeneTok TNcnameTok expected.",
			"TRightParenTok TCommaTok expected.",
			"TRightSquareTok expected.",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 2, 3, 3, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 2, 3, 3, 3, 2, 2, 3, 2, 2, 2, 3, 2, 2, 4, 2, 3, 2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 3, 4, 4, 2, 2, 2, 2, 5, 0, 5, 5, 6, 7, 8, 9, 10, 10, 0, 11, 12, 3, 5, 5, 5, 6, 2, 5, 13, 10, 10, 0, 14, 0, 15, 0, 16, 0, 17, 0, 0, 18, 19, 20, 19, 0, 10, 0, 0, 0, 0, 0, 0, 20, 5, 4, 5, 5, 5, 4, 11, 5, 10, 10, 21, 6, 0, 5, 5, 5, 5, 22, 0, 4, 0, 8, 10, 5, 20, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 10, 0, 17, 0, 16, 0, 18, 0, 19, 14, 0, 0, 19, 13, 20, 5, 5, 7, 5, 5, 23, 5, 5, 0, 5, 22, 0, 10, 5, 
        };*/
}
